#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include "windows.h"
#endif

#include "math.h"

#include "Lightning.h"


Lightning::Lightning(float startx,float starty)
{
	// Simple Lightning:
	int n_points = 10;
	int i;
	float prev_x = startx;
	float prev_y = starty;
	float prev_w = 1.0f;
	float x,y,w;

	for(i=0;i<n_points;i++) {
		x = prev_x + (rand()%64)-32;
		y = prev_y + 16 + (rand()&40);
		w = prev_w *0.8f;

		m_x1.Add(new float(prev_x));
		m_y1.Add(new float(prev_y));
		m_w1.Add(new float(prev_w));
		m_x2.Add(new float(x));
		m_y2.Add(new float(y));
		m_w2.Add(new float(w));

		// Create some appendixes:
		if ((rand()%2)==0) {
			m_x1.Add(new float(prev_x));
			m_y1.Add(new float(prev_y));
			m_w1.Add(new float(prev_w));
			m_x2.Add(new float(prev_x-(x-prev_x)));
			m_y2.Add(new float(prev_y + 16 + (rand()&40)));
			m_w2.Add(new float(w));
		} // if 

		prev_x = x;
		prev_y = y;
		prev_w = w;
	} // for	

} // Lightning::Lightning


void Lightning::draw(float r,float g,float b,float a)
{
	float *x,*y,*w;
	glBegin(GL_QUADS);
	m_x1.Rewind();
	m_y1.Rewind();
	m_w1.Rewind();
	m_x2.Rewind();
	m_y2.Rewind();
	m_w2.Rewind();

	while(m_x1.Iterate(x)) {
		m_y1.Iterate(y);
		m_w1.Iterate(w);

//		glColor4f(r,g,b,a*(*w));
		glColor4f(r,g,b,a);
		glVertex3f((*x)-2.0f*(*w),*y,0);
		glVertex3f((*x)+2.0f*(*w),*y,0);

		m_x2.Iterate(x);
		m_y2.Iterate(y);
		m_w2.Iterate(w);

//		glColor4f(r,g,b,a*(*w));
		glVertex3f((*x)+2.0f*(*w),*y,0);
		glVertex3f((*x)-2.0f*(*w),*y,0);
	} // while 
	glEnd();

	glPointSize(1.0f);

} // Lightning::draw


